﻿Public Class UTL_Com

    ''' <summary>
    ''' 参考：http://jeanne.wankuma.com/tips/vb.net/form/findcontrol.html
    ''' </summary>
    ''' <param name="hParent"></param>
    ''' <param name="stName"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function FindControl(ByVal hParent As Control, ByVal stName As String) As Control
        ' hParent 内のすべてのコントロールを列挙する
        For Each cControl As Control In hParent.Controls
            ' 列挙したコントロールにコントロールが含まれている場合は再帰呼び出しする
            If cControl.HasChildren Then
                Dim cFindControl As Control = FindControl(cControl, stName)

                ' 再帰呼び出し先でコントロールが見つかった場合はそのまま返す
                If Not cFindControl Is Nothing Then
                    Return cFindControl
                End If
            End If

            ' コントロール名が合致した場合はそのコントロールのインスタンスを返す
            If cControl.Name = stName Then
                Return cControl
            End If
        Next cControl
        '
        Return Nothing
    End Function

End Class
